
/////FOTORESISTOR KODE///////

//FOTORESISTOR setup m. diodeindikation af Kasper Thorn Ljungdahl - 28-11-18
//Huskeregel: God kode er simpel, forståelig og godt forklaret. Kald de forskellige variable meningsfyldte navne  

//Der er mange forskellige programmeringssprog. Generelt defineres ens variable med engelske navne, men hele setup'et 
//og hvordan programmeringen skal skrives, varierer meget fra sprog til sprog. F.eks. findes der
//programmeringssprogene: Python, Matlab, Java, HTML, C-sharp, C, C++, Fortran, R, Go, Ruby osv...Hver har deres force og forskelligheder.
//Rigtig mange programmeringssprog kræver, at man laver indhak i koden for at den fungerer. Dette er ikke tilfældet ved Arduino, men det er god skik,
//som sikre orden og overblik. Derudover er det meget nemmere, at tilgå et nyt programmeringssprog, hvis man har lært sig denne vane fra starten. 

//SPROGET I ARDUINO IDE er et C/C++ programmeringssprog. 
//Skriver man // foran noget tekst, så tæller linjen efter ikke med i koden. 
//Derfor kan man bruge dette tegn til, at forklare hvad man gør i sin kode. Dette bør man gøre regelmæssigt.
//Hver programmeringslinje, skal afsluttes med et semikolon ; ellers virker koden ikke. 

/////  HER STARTER KODEN  /////
//Først skal vi fortælle Arduino IDE, hvilket kredsløb vi har sat op, og gerne vil programmere.
//Læg mærke til semikolonnet ; efter hver linje

int greenLedPin = 2;  //Her defineres det, at der er sat tre variabel i hhv. digitalindgang 2,3 og 4
int yellowLedPin = 3; //Det er en god ide, at skrive forklaringen ud for hver linje, så man ved præcis, hvor forklaringen hører til.
int redLedPin = 4;    //Læg mærke til, at jeg kalder dioderne ved deres engelske navne. Det gør ens egen kode delbar, med resten af verden. God skik. 

int lightSensorPin = A0; //Her defineres det, at der er en variabel i analog indgang A0, som kaldes for lightSensorPin
float analogValue = 0; //Her defineres det, at værdien, som fotoresistoren måler til indgang A0, er en float værdi.
                        //Det betyder, at det målte tal, kan være et decimaltal og ikke blot et helttal.

//I sektionen void setup skrives alt, som skal være uændret undervejs i vores programmering. F.eks. 
//skriver vi her, at vi ønsker Serial.begin(9600);, hvilket betyder, at terminalen, som kommer frem når vi kører koden
//skal opdateres med 9600 bits hvert sekund. Dette kan man varierer efter behov for, hvor hurtigt man ønsker en ny kørsel af koden
//Dets højere man sætter det, dets mere regnekraft forlanger man. Serial.begin(9600); er rigeligt til alt vi skal bruge.

void setup() {

Serial.begin(9600); 

  pinMode(greenLedPin,OUTPUT); //Her defineres det, at de digitale pins vi bruger til dioderne, altid er output. 
  pinMode(yellowLedPin,OUTPUT); //Arduinoen skal altså aktivt sende noget ud i kredsløbet og ikke modtaget noget, når en særlig måling eller værdi er gældende. 
  pinMode(redLedPin,OUTPUT); //Havde vi skulle modtage noget, havde vi skrevet INPUT i stedet for. 
}

//I void loop skrives alt, som man gerne vil have til at køre igen og igen i kredsløbet. F.eks vil vi gerne her
//havde fotoresistoren til ikke bare at måle en gang, men kontinuerligt, så vi hele tiden, får nye værdier for lysintensiteten
//På samme måde vil vi også gerne hele tiden have Arduinoen til at tage stilling til, hvilken diode der skal være tændt
//på baggrund af, hvilken ny lysintensitet, som fotoresistoren har målt. 

void loop(){
  analogValue = analogRead(lightSensorPin); //Her defineres en variabel som kaldes for analogValue. 
                                            //Vi fortæller arduinoen at den skal aflæse det analoge signal fra fotoresistoren
                                            //og gemme det som værdien analogValue. Lidt ligesom x = måling fra fotoresistor  
  
                                           //Her laver vi et "if" loop. Vi siger egentlig til Arduinoen, at hvis  
                                            //analogValue er mindre end 60, så tænd rød diode(if-delen). Hvis analogValue er                                      
                                            //større eller lig med 60, men mindre eller lig med 130 så tænd for den gule diod            
  if(analogValue < 60){                     //(else if-delen), hvis analogValue er større end 130 så tænd den grønne diode (else-delen).
    digitalWrite(redLedPin, HIGH);
  }
  else if(analogValue >= 60 && analogValue <= 130){ //læg mærke til tuborgklemmerne, som man bruger efter if og else delene
    digitalWrite(yellowLedPin, HIGH);              //Man kan selv vælge andre værdier end 60 og 130, alt efter situationen i lokalet.
  }
  else{
    digitalWrite(greenLedPin, HIGH);        
  }
  
  delay(1000);                              //Efter if loopet, beder vi Arduinoen om at vende 1000 millisekunder, inden en ny måling tages.
  digitalWrite(greenLedPin, LOW);           //Hver loop afsluttes med at alle tre dioder slukkes
  digitalWrite(yellowLedPin, LOW);          //inden vi på ny spørger til en ny analogValue fra fotoresistoren. 
  digitalWrite(redLedPin, LOW);

  Serial.println(analogValue);              //Her beder vi om at printe værdien fra fotoresistoren i terminalen, så vi får tallet for målingen ud 
  delay(1);                                 //Venter kortvarigt, inden vi starter loopet igen. Loppet kører indtil vi slutter programmet selv.       
  
} //Afsluttende tuborgklemme fra void loop loopet. 
